/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or html_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with html or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 14 "../../lib/common/htmlparse.y"


#include "render.h"
#include "htmltable.h"
#include "htmllex.h"

extern int htmlparse(void);

typedef struct sfont_t {
    textfont_t *cfont;	
    struct sfont_t *pfont;
} sfont_t;

static struct {
  htmllabel_t* lbl;       /* Generated label */
  htmltbl_t*   tblstack;  /* Stack of tables maintained during parsing */
  Dt_t*        fitemList; /* Dictionary for font text items */
  Dt_t*        fspanList; 
  agxbuf*      str;       /* Buffer for text */
  sfont_t*     fontstack;
  GVC_t*       gvc;
} HTMLstate;

/* free_ritem:
 * Free row. This closes and frees row's list, then
 * the pitem itself is freed.
 */
static void
free_ritem(Dt_t* d, pitem* p,Dtdisc_t* ds)
{
  dtclose (p->u.rp);
  free (p);
}

/* free_item:
 * Generic Dt free. Only frees container, assuming contents
 * have been copied elsewhere.
 */
static void
free_item(Dt_t* d, void* p,Dtdisc_t* ds)
{
  free (p);
}

/* cleanTbl:
 * Clean up table if error in parsing.
 */
static void
cleanTbl (htmltbl_t* tp)
{
  dtclose (tp->u.p.rows);
  free_html_data (&tp->data);
  free (tp);
}

/* cleanCell:
 * Clean up cell if error in parsing.
 */
static void
cleanCell (htmlcell_t* cp)
{
  if (cp->child.kind == HTML_TBL) cleanTbl (cp->child.u.tbl);
  else if (cp->child.kind == HTML_TEXT) free_html_text (cp->child.u.txt);
  free_html_data (&cp->data);
  free (cp);
}

/* free_citem:
 * Free cell item during parsing. This frees cell and pitem.
 */
static void
free_citem(Dt_t* d, pitem* p,Dtdisc_t* ds)
{
  cleanCell (p->u.cp);
  free (p);
}

static Dtdisc_t rowDisc = {
    offsetof(pitem,u),
    sizeof(void*),
    offsetof(pitem,link),
    NIL(Dtmake_f),
    (Dtfree_f)free_ritem,
    NIL(Dtcompar_f),
    NIL(Dthash_f),
    NIL(Dtmemory_f),
    NIL(Dtevent_f)
};
static Dtdisc_t cellDisc = {
    offsetof(pitem,u),
    sizeof(void*),
    offsetof(pitem,link),
    NIL(Dtmake_f),
    (Dtfree_f)free_item,
    NIL(Dtcompar_f),
    NIL(Dthash_f),
    NIL(Dtmemory_f),
    NIL(Dtevent_f)
};

typedef struct {
    Dtlink_t    link;
    textspan_t  ti;
} fitem;

typedef struct {
    Dtlink_t     link;
    htextspan_t  lp;
} fspan;

static void 
free_fitem(Dt_t* d, fitem* p, Dtdisc_t* ds)
{
    if (p->ti.str)
	free (p->ti.str);
    free (p);
}

static void 
free_fspan(Dt_t* d, fspan* p, Dtdisc_t* ds)
{
    textspan_t* ti;

    if (p->lp.nitems) {
	int i;
	ti = p->lp.items;
	for (i = 0; i < p->lp.nitems; i++) {
	    if (ti->str) free (ti->str);
	    ti++;
	}
	free (p->lp.items);
    }
    free (p);
}

static Dtdisc_t fstrDisc = {
    0,
    0,
    offsetof(fitem,link),
    NIL(Dtmake_f),
    (Dtfree_f)free_item,
    NIL(Dtcompar_f),
    NIL(Dthash_f),
    NIL(Dtmemory_f),
    NIL(Dtevent_f)
};


static Dtdisc_t fspanDisc = {
    0,
    0,
    offsetof(fspan,link),
    NIL(Dtmake_f),
    (Dtfree_f)free_item,
    NIL(Dtcompar_f),
    NIL(Dthash_f),
    NIL(Dtmemory_f),
    NIL(Dtevent_f)
};

/* appendFItemList:
 * Append a new fitem to the list.
 */
static void
appendFItemList (agxbuf *ag)
{
    fitem *fi = NEW(fitem);

    fi->ti.str = strdup(agxbuse(ag));
    fi->ti.font = HTMLstate.fontstack->cfont;
    dtinsert(HTMLstate.fitemList, fi);
}	

/* appendFLineList:
 */
static void 
appendFLineList (int v)
{
    int cnt;
    fspan *ln = NEW(fspan);
    fitem *fi;
    Dt_t *ilist = HTMLstate.fitemList;

    cnt = dtsize(ilist);
    ln->lp.just = v;
    if (cnt) {
        int i = 0;
	ln->lp.nitems = cnt;
	ln->lp.items = N_NEW(cnt, textspan_t);

	fi = (fitem*)dtflatten(ilist);
	for (; fi; fi = (fitem*)dtlink(fitemList,(Dtlink_t*)fi)) {
		/* NOTE: When fitemList is closed, it uses free_item, which only frees the container,
		 * not the contents, so this copy is safe.
		 */
	    ln->lp.items[i] = fi->ti;  
	    i++;
	}
    }
    else {
	ln->lp.items = NEW(textspan_t);
	ln->lp.nitems = 1;
	ln->lp.items[0].str = strdup("");
	ln->lp.items[0].font = HTMLstate.fontstack->cfont;
    }

    dtclear(ilist);

    dtinsert(HTMLstate.fspanList, ln);
}

static htmltxt_t*
mkText(void)
{
    int cnt;
    Dt_t * ispan = HTMLstate.fspanList;
    fspan *fl ;
    htmltxt_t *hft = NEW(htmltxt_t);
    
    if (dtsize (HTMLstate.fitemList)) 
	appendFLineList (UNSET_ALIGN);

    cnt = dtsize(ispan);
    hft->nspans = cnt;
    	
    if (cnt) {
	int i = 0;
	hft->spans = N_NEW(cnt,htextspan_t);	
    	for(fl=(fspan *)dtfirst(ispan); fl; fl=(fspan *)dtnext(ispan,fl)) {
    	    hft->spans[i] = fl->lp;
    	    i++;
    	}
    }
    
    dtclear(ispan);

    return hft;
}

static pitem* lastRow (void)
{
  htmltbl_t* tbl = HTMLstate.tblstack;
  pitem*     sp = dtlast (tbl->u.p.rows);
  return sp;
}

/* addRow:
 * Add new cell row to current table.
 */
static pitem* addRow (void)
{
  Dt_t*      dp = dtopen(&cellDisc, Dtqueue);
  htmltbl_t* tbl = HTMLstate.tblstack;
  pitem*     sp = NEW(pitem);
  sp->u.rp = dp;
  if (tbl->flags & HTML_HRULE)
    sp->ruled = 1;
  dtinsert (tbl->u.p.rows, sp);
  return sp;
}

/* setCell:
 * Set cell body and type and attach to row
 */
static void setCell (htmlcell_t* cp, void* obj, int kind)
{
  pitem*     sp = NEW(pitem);
  htmltbl_t* tbl = HTMLstate.tblstack;
  pitem*     rp = (pitem*)dtlast (tbl->u.p.rows);
  Dt_t*      row = rp->u.rp;
  sp->u.cp = cp;
  dtinsert (row, sp);
  cp->child.kind = kind;
  if (tbl->flags & HTML_VRULE)
    cp->ruled = HTML_VRULE;
  
  if(kind == HTML_TEXT)
  	cp->child.u.txt = (htmltxt_t*)obj;
  else if (kind == HTML_IMAGE)
    cp->child.u.img = (htmlimg_t*)obj;
  else
    cp->child.u.tbl = (htmltbl_t*)obj;
}

/* mkLabel:
 * Create label, given body and type.
 */
static htmllabel_t* mkLabel (void* obj, int kind)
{
  htmllabel_t* lp = NEW(htmllabel_t);

  lp->kind = kind;
  if (kind == HTML_TEXT)
    lp->u.txt = (htmltxt_t*)obj;
  else
    lp->u.tbl = (htmltbl_t*)obj;
  return lp;
}

/* freeFontstack:
 * Free all stack items but the last, which is
 * put on artificially during in parseHTML.
 */
static void
freeFontstack(void)
{
    sfont_t* s;
    sfont_t* next;

    for (s = HTMLstate.fontstack; (next = s->pfont); s = next) {
	free(s);
    }
}

/* cleanup:
 * Called on error. Frees resources allocated during parsing.
 * This includes a label, plus a walk down the stack of
 * tables. Note that we use the free_citem function to actually
 * free cells.
 */
static void cleanup (void)
{
  htmltbl_t* tp = HTMLstate.tblstack;
  htmltbl_t* next;

  if (HTMLstate.lbl) {
    free_html_label (HTMLstate.lbl,1);
    HTMLstate.lbl = NULL;
  }
  cellDisc.freef = (Dtfree_f)free_citem;
  while (tp) {
    next = tp->u.p.prev;
    cleanTbl (tp);
    tp = next;
  }
  cellDisc.freef = (Dtfree_f)free_item;

  fstrDisc.freef = (Dtfree_f)free_fitem;
  dtclear (HTMLstate.fitemList);
  fstrDisc.freef = (Dtfree_f)free_item;

  fspanDisc.freef = (Dtfree_f)free_fspan;
  dtclear (HTMLstate.fspanList);
  fspanDisc.freef = (Dtfree_f)free_item;

  freeFontstack();
}

/* nonSpace:
 * Return 1 if s contains a non-space character.
 */
static int nonSpace (char* s)
{
  char   c;

  while ((c = *s++)) {
    if (c != ' ') return 1;
  }
  return 0;
}

/* pushFont:
 * Fonts are allocated in the lexer.
 */
static void
pushFont (textfont_t *fp)
{
    sfont_t *ft = NEW(sfont_t);
    textfont_t* curfont = HTMLstate.fontstack->cfont;
    textfont_t  f = *fp;

    if (curfont) {
	if (!f.color && curfont->color)
	    f.color = curfont->color;
	if ((f.size < 0.0) && (curfont->size >= 0.0))
	    f.size = curfont->size;
	if (!f.name && curfont->name)
	    f.name = curfont->name;
	if (curfont->flags)
	    f.flags |= curfont->flags;
    }

    ft->cfont = dtinsert(HTMLstate.gvc->textfont_dt, &f);
    ft->pfont = HTMLstate.fontstack;
    HTMLstate.fontstack = ft;
}

/* popFont:
 */
static void 
popFont (void)
{
    sfont_t* curfont = HTMLstate.fontstack;
    sfont_t* prevfont = curfont->pfont;

    free (curfont);
    HTMLstate.fontstack = prevfont;
}


#line 472 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int htmldebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum htmltokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    T_end_br = 258,                /* T_end_br  */
    T_end_img = 259,               /* T_end_img  */
    T_row = 260,                   /* T_row  */
    T_end_row = 261,               /* T_end_row  */
    T_html = 262,                  /* T_html  */
    T_end_html = 263,              /* T_end_html  */
    T_end_table = 264,             /* T_end_table  */
    T_end_cell = 265,              /* T_end_cell  */
    T_end_font = 266,              /* T_end_font  */
    T_string = 267,                /* T_string  */
    T_error = 268,                 /* T_error  */
    T_n_italic = 269,              /* T_n_italic  */
    T_n_bold = 270,                /* T_n_bold  */
    T_n_underline = 271,           /* T_n_underline  */
    T_n_overline = 272,            /* T_n_overline  */
    T_n_sup = 273,                 /* T_n_sup  */
    T_n_sub = 274,                 /* T_n_sub  */
    T_n_s = 275,                   /* T_n_s  */
    T_HR = 276,                    /* T_HR  */
    T_hr = 277,                    /* T_hr  */
    T_end_hr = 278,                /* T_end_hr  */
    T_VR = 279,                    /* T_VR  */
    T_vr = 280,                    /* T_vr  */
    T_end_vr = 281,                /* T_end_vr  */
    T_BR = 282,                    /* T_BR  */
    T_br = 283,                    /* T_br  */
    T_IMG = 284,                   /* T_IMG  */
    T_img = 285,                   /* T_img  */
    T_table = 286,                 /* T_table  */
    T_cell = 287,                  /* T_cell  */
    T_font = 288,                  /* T_font  */
    T_italic = 289,                /* T_italic  */
    T_bold = 290,                  /* T_bold  */
    T_underline = 291,             /* T_underline  */
    T_overline = 292,              /* T_overline  */
    T_sup = 293,                   /* T_sup  */
    T_sub = 294,                   /* T_sub  */
    T_s = 295                      /* T_s  */
  };
  typedef enum htmltokentype htmltoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define T_end_br 258
#define T_end_img 259
#define T_row 260
#define T_end_row 261
#define T_html 262
#define T_end_html 263
#define T_end_table 264
#define T_end_cell 265
#define T_end_font 266
#define T_string 267
#define T_error 268
#define T_n_italic 269
#define T_n_bold 270
#define T_n_underline 271
#define T_n_overline 272
#define T_n_sup 273
#define T_n_sub 274
#define T_n_s 275
#define T_HR 276
#define T_hr 277
#define T_end_hr 278
#define T_VR 279
#define T_vr 280
#define T_end_vr 281
#define T_BR 282
#define T_br 283
#define T_IMG 284
#define T_img 285
#define T_table 286
#define T_cell 287
#define T_font 288
#define T_italic 289
#define T_bold 290
#define T_underline 291
#define T_overline 292
#define T_sup 293
#define T_sub 294
#define T_s 295

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 415 "../../lib/common/htmlparse.y"

  int    i;
  htmltxt_t*  txt;
  htmlcell_t*  cell;
  htmltbl_t*   tbl;
  textfont_t*  font;
  htmlimg_t*   img;
  pitem*       p;

#line 615 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE htmllval;

int htmlparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum htmlsymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_end_br = 3,                   /* T_end_br  */
  YYSYMBOL_T_end_img = 4,                  /* T_end_img  */
  YYSYMBOL_T_row = 5,                      /* T_row  */
  YYSYMBOL_T_end_row = 6,                  /* T_end_row  */
  YYSYMBOL_T_html = 7,                     /* T_html  */
  YYSYMBOL_T_end_html = 8,                 /* T_end_html  */
  YYSYMBOL_T_end_table = 9,                /* T_end_table  */
  YYSYMBOL_T_end_cell = 10,                /* T_end_cell  */
  YYSYMBOL_T_end_font = 11,                /* T_end_font  */
  YYSYMBOL_T_string = 12,                  /* T_string  */
  YYSYMBOL_T_error = 13,                   /* T_error  */
  YYSYMBOL_T_n_italic = 14,                /* T_n_italic  */
  YYSYMBOL_T_n_bold = 15,                  /* T_n_bold  */
  YYSYMBOL_T_n_underline = 16,             /* T_n_underline  */
  YYSYMBOL_T_n_overline = 17,              /* T_n_overline  */
  YYSYMBOL_T_n_sup = 18,                   /* T_n_sup  */
  YYSYMBOL_T_n_sub = 19,                   /* T_n_sub  */
  YYSYMBOL_T_n_s = 20,                     /* T_n_s  */
  YYSYMBOL_T_HR = 21,                      /* T_HR  */
  YYSYMBOL_T_hr = 22,                      /* T_hr  */
  YYSYMBOL_T_end_hr = 23,                  /* T_end_hr  */
  YYSYMBOL_T_VR = 24,                      /* T_VR  */
  YYSYMBOL_T_vr = 25,                      /* T_vr  */
  YYSYMBOL_T_end_vr = 26,                  /* T_end_vr  */
  YYSYMBOL_T_BR = 27,                      /* T_BR  */
  YYSYMBOL_T_br = 28,                      /* T_br  */
  YYSYMBOL_T_IMG = 29,                     /* T_IMG  */
  YYSYMBOL_T_img = 30,                     /* T_img  */
  YYSYMBOL_T_table = 31,                   /* T_table  */
  YYSYMBOL_T_cell = 32,                    /* T_cell  */
  YYSYMBOL_T_font = 33,                    /* T_font  */
  YYSYMBOL_T_italic = 34,                  /* T_italic  */
  YYSYMBOL_T_bold = 35,                    /* T_bold  */
  YYSYMBOL_T_underline = 36,               /* T_underline  */
  YYSYMBOL_T_overline = 37,                /* T_overline  */
  YYSYMBOL_T_sup = 38,                     /* T_sup  */
  YYSYMBOL_T_sub = 39,                     /* T_sub  */
  YYSYMBOL_T_s = 40,                       /* T_s  */
  YYSYMBOL_YYACCEPT = 41,                  /* $accept  */
  YYSYMBOL_html = 42,                      /* html  */
  YYSYMBOL_fonttext = 43,                  /* fonttext  */
  YYSYMBOL_text = 44,                      /* text  */
  YYSYMBOL_textitem = 45,                  /* textitem  */
  YYSYMBOL_font = 46,                      /* font  */
  YYSYMBOL_n_font = 47,                    /* n_font  */
  YYSYMBOL_italic = 48,                    /* italic  */
  YYSYMBOL_n_italic = 49,                  /* n_italic  */
  YYSYMBOL_bold = 50,                      /* bold  */
  YYSYMBOL_n_bold = 51,                    /* n_bold  */
  YYSYMBOL_strike = 52,                    /* strike  */
  YYSYMBOL_n_strike = 53,                  /* n_strike  */
  YYSYMBOL_underline = 54,                 /* underline  */
  YYSYMBOL_n_underline = 55,               /* n_underline  */
  YYSYMBOL_overline = 56,                  /* overline  */
  YYSYMBOL_n_overline = 57,                /* n_overline  */
  YYSYMBOL_sup = 58,                       /* sup  */
  YYSYMBOL_n_sup = 59,                     /* n_sup  */
  YYSYMBOL_sub = 60,                       /* sub  */
  YYSYMBOL_n_sub = 61,                     /* n_sub  */
  YYSYMBOL_br = 62,                        /* br  */
  YYSYMBOL_string = 63,                    /* string  */
  YYSYMBOL_table = 64,                     /* table  */
  YYSYMBOL_65_1 = 65,                      /* @1  */
  YYSYMBOL_fonttable = 66,                 /* fonttable  */
  YYSYMBOL_opt_space = 67,                 /* opt_space  */
  YYSYMBOL_rows = 68,                      /* rows  */
  YYSYMBOL_row = 69,                       /* row  */
  YYSYMBOL_70_2 = 70,                      /* $@2  */
  YYSYMBOL_cells = 71,                     /* cells  */
  YYSYMBOL_cell = 72,                      /* cell  */
  YYSYMBOL_73_3 = 73,                      /* $@3  */
  YYSYMBOL_74_4 = 74,                      /* $@4  */
  YYSYMBOL_75_5 = 75,                      /* $@5  */
  YYSYMBOL_76_6 = 76,                      /* $@6  */
  YYSYMBOL_image = 77,                     /* image  */
  YYSYMBOL_HR = 78,                        /* HR  */
  YYSYMBOL_VR = 79                         /* VR  */
};
typedef enum htmlsymbol_kind_t htmlsymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ htmltype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t htmltype_int8;
#else
typedef signed char htmltype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ htmltype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t htmltype_int16;
#else
typedef short htmltype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ htmltype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t htmltype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char htmltype_uint8;
#else
typedef short htmltype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ htmltype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t htmltype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short htmltype_uint16;
#else
typedef int htmltype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef htmltype_int8 html_state_t;

/* State numbers in computations.  */
typedef int html_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about htmllval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined htmloverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined htmloverflow */

#if (! defined htmloverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union htmlalloc
{
  html_state_t htmlss_alloc;
  YYSTYPE htmlvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union htmlalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (html_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T htmlnewbytes;                                         \
        YYCOPY (&htmlptr->Stack_alloc, Stack, htmlsize);                    \
        Stack = &htmlptr->Stack_alloc;                                    \
        htmlnewbytes = htmlstacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        htmlptr += htmlnewbytes / YYSIZEOF (*htmlptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T htmli;                      \
          for (htmli = 0; htmli < (Count); htmli++)   \
            (Dst)[htmli] = (Src)[htmli];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  31
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   271

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  41
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  39
/* YYNRULES -- Number of rules.  */
#define YYNRULES  69
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  116

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   295


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by htmllex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (htmlsymbol_kind_t, htmltranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by htmllex.  */
static const htmltype_int8 htmltranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const htmltype_int16 htmlrline[] =
{
       0,   447,   447,   448,   449,   452,   455,   456,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   471,   474,
     477,   480,   483,   486,   489,   492,   495,   498,   501,   504,
     507,   510,   513,   516,   519,   520,   523,   524,   527,   527,
     548,   549,   550,   551,   552,   553,   556,   557,   560,   561,
     562,   565,   565,   568,   569,   570,   573,   573,   574,   574,
     575,   575,   576,   576,   579,   580,   583,   584,   587,   588
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (htmlsymbol_kind_t, htmlstos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *htmlsymbol_name (htmlsymbol_kind_t htmlsymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const htmltname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_end_br",
  "T_end_img", "T_row", "T_end_row", "T_html", "T_end_html", "T_end_table",
  "T_end_cell", "T_end_font", "T_string", "T_error", "T_n_italic",
  "T_n_bold", "T_n_underline", "T_n_overline", "T_n_sup", "T_n_sub",
  "T_n_s", "T_HR", "T_hr", "T_end_hr", "T_VR", "T_vr", "T_end_vr", "T_BR",
  "T_br", "T_IMG", "T_img", "T_table", "T_cell", "T_font", "T_italic",
  "T_bold", "T_underline", "T_overline", "T_sup", "T_sub", "T_s",
  "$accept", "html", "fonttext", "text", "textitem", "font", "n_font",
  "italic", "n_italic", "bold", "n_bold", "strike", "n_strike",
  "underline", "n_underline", "overline", "n_overline", "sup", "n_sup",
  "sub", "n_sub", "br", "string", "table", "@1", "fonttable", "opt_space",
  "rows", "row", "$@2", "cells", "cell", "$@3", "$@4", "$@5", "$@6",
  "image", "HR", "VR", YY_NULLPTR
};

static const char *
htmlsymbol_name (htmlsymbol_kind_t htmlsymbol)
{
  return htmltname[htmlsymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const htmltype_int16 htmltoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295
};
#endif

#define YYPACT_NINF (-82)

#define htmlpact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-63)

#define htmltable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const htmltype_int16 htmlpact[] =
{
       8,   -82,   209,    10,   -82,   -82,    11,   -82,   -82,   -82,
     -82,   -82,   -82,   -82,   -82,     5,   209,   -82,   209,   209,
     209,   209,   209,   209,   209,   209,   -82,    -5,   -82,    14,
     -20,   -82,   -82,   -82,   -82,   209,   209,   209,   209,   209,
      13,    37,    12,    66,    16,    80,    19,   109,   123,    20,
     152,    15,   166,   195,   -82,   -82,   -82,   -82,   -82,   -82,
     -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,
     -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,    23,   -82,
     119,   -82,     7,    46,   -82,    38,   -82,    23,    17,    35,
     -82,    13,   -82,   -82,   -82,   -82,    58,   -82,   -82,    53,
     -82,   -82,   -82,    40,   -82,     7,   -82,    59,    69,   -82,
      72,   -82,   -82,   -82,   -82,   -82
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const htmltype_int8 htmldefact[] =
{
       0,     4,    47,     0,    36,    35,     0,    18,    20,    22,
      26,    28,    30,    32,    24,     0,     5,     7,    47,    47,
      47,     0,    47,    47,     0,     0,     9,     8,    40,     0,
       0,     1,    34,     2,     6,     0,     0,     0,     0,     0,
       8,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    37,     3,    38,    19,    10,    41,
      21,    11,    42,    23,    14,    45,    25,    17,    27,    12,
      43,    29,    13,    44,    31,    15,    33,    16,     0,    51,
       0,    48,     0,    47,    67,     0,    49,     0,    47,     0,
      53,    46,    39,    66,    50,    65,     0,    58,    56,     0,
      60,    52,    69,     0,    54,     0,    64,     0,     0,    63,
       0,    68,    55,    59,    57,    61
};

  /* YYPGOTO[NTERM-NUM].  */
static const htmltype_int16 htmlpgoto[] =
{
     -82,   -82,    -4,   232,   -10,    -1,    26,     0,    39,     1,
      50,   -82,   -82,     2,    36,     3,    47,   -82,   -82,   -82,
     -82,   -82,    -2,   148,   -82,     9,    27,   -82,   -68,   -82,
     -82,   -81,   -82,   -82,   -82,   -82,   -82,   -82,   -82
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const htmltype_int8 htmldefgoto[] =
{
      -1,     3,    15,    16,    17,    35,    58,    36,    61,    37,
      64,    21,    67,    38,    69,    39,    72,    24,    75,    25,
      77,    26,    40,    28,    78,    29,    30,    80,    81,    82,
      89,    90,   108,   107,   110,    99,   100,    87,   105
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const htmltype_int8 htmltable[] =
{
      27,    18,    19,    20,    22,    23,    34,    54,   104,     1,
      31,    56,    86,    33,    32,     2,    27,    27,    27,    94,
      27,    27,    55,    57,   112,    54,   -46,   -62,    79,     4,
      60,    34,    71,    34,    63,    34,    68,    34,    34,    88,
      34,   101,    34,    34,     5,     6,    95,    96,    57,     4,
       7,     8,     9,    10,    11,    12,    13,    14,     4,   102,
     103,    93,   106,   109,     5,     6,   111,    88,    59,   113,
       7,     8,     9,    10,    11,    12,    13,    14,     4,   114,
      60,    91,   115,    62,    97,    70,    27,    18,    19,    20,
      22,    23,     4,     5,     6,    63,    65,    98,    73,     7,
       8,     9,    10,    11,    12,    13,    14,     5,     6,     0,
      92,     0,     0,     7,     8,     9,    10,    11,    12,    13,
      14,     4,     0,     0,    79,     0,     0,     0,    83,    66,
       0,     0,     0,     0,     0,     4,     5,     6,     0,    68,
      84,    85,     7,     8,     9,    10,    11,    12,    13,    14,
       5,     6,     0,     0,     0,     0,     7,     8,     9,    10,
      11,    12,    13,    14,     4,     0,    42,    44,    46,    71,
      49,    51,     0,     0,     0,     0,     0,     0,     4,     5,
       6,     0,     0,     0,    74,     7,     8,     9,    10,    11,
      12,    13,    14,     5,     6,     0,     0,     0,     0,     7,
       8,     9,    10,    11,    12,    13,    14,     4,     0,     0,
       0,     0,     0,     0,    76,     0,     0,     0,     0,     0,
       0,     4,     5,     6,     0,     0,     0,     0,     7,     8,
       9,    10,    11,    12,    13,    14,     5,     6,     0,     0,
       0,     0,     7,     8,     9,    10,    11,    12,    13,    14,
      41,    43,    45,    47,    48,    50,    52,    53,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,    43,    45,
      48,    50
};

static const htmltype_int8 htmlcheck[] =
{
       2,     2,     2,     2,     2,     2,    16,    12,    89,     1,
       0,    31,    80,     8,     3,     7,    18,    19,    20,    87,
      22,    23,     8,    11,   105,    12,    31,    10,     5,    12,
      14,    41,    17,    43,    15,    45,    16,    47,    48,    32,
      50,     6,    52,    53,    27,    28,    29,    30,    11,    12,
      33,    34,    35,    36,    37,    38,    39,    40,    12,    24,
      25,    23,     4,    10,    27,    28,    26,    32,    42,    10,
      33,    34,    35,    36,    37,    38,    39,    40,    12,    10,
      14,    83,    10,    44,    88,    49,    88,    88,    88,    88,
      88,    88,    12,    27,    28,    15,    46,    88,    51,    33,
      34,    35,    36,    37,    38,    39,    40,    27,    28,    -1,
      83,    -1,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    12,    -1,    -1,     5,    -1,    -1,    -1,     9,    20,
      -1,    -1,    -1,    -1,    -1,    12,    27,    28,    -1,    16,
      21,    22,    33,    34,    35,    36,    37,    38,    39,    40,
      27,    28,    -1,    -1,    -1,    -1,    33,    34,    35,    36,
      37,    38,    39,    40,    12,    -1,    18,    19,    20,    17,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    12,    27,
      28,    -1,    -1,    -1,    18,    33,    34,    35,    36,    37,
      38,    39,    40,    27,    28,    -1,    -1,    -1,    -1,    33,
      34,    35,    36,    37,    38,    39,    40,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    12,    27,    28,    -1,    -1,    -1,    -1,    33,    34,
      35,    36,    37,    38,    39,    40,    27,    28,    -1,    -1,
      -1,    -1,    33,    34,    35,    36,    37,    38,    39,    40,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    37,
      38,    39
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const htmltype_int8 htmlstos[] =
{
       0,     1,     7,    42,    12,    27,    28,    33,    34,    35,
      36,    37,    38,    39,    40,    43,    44,    45,    46,    48,
      50,    52,    54,    56,    58,    60,    62,    63,    64,    66,
      67,     0,     3,     8,    45,    46,    48,    50,    54,    56,
      63,    44,    64,    44,    64,    44,    64,    44,    44,    64,
      44,    64,    44,    44,    12,     8,    31,    11,    47,    47,
      14,    49,    49,    15,    51,    51,    20,    53,    16,    55,
      55,    17,    57,    57,    18,    59,    19,    61,    65,     5,
      68,    69,    70,     9,    21,    22,    69,    78,    32,    71,
      72,    63,    67,    23,    69,    29,    30,    43,    66,    76,
      77,     6,    24,    25,    72,    79,     4,    74,    73,    10,
      75,    26,    72,    10,    10,    10
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const htmltype_int8 htmlr1[] =
{
       0,    41,    42,    42,    42,    43,    44,    44,    45,    45,
      45,    45,    45,    45,    45,    45,    45,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    62,    63,    63,    65,    64,
      66,    66,    66,    66,    66,    66,    67,    67,    68,    68,
      68,    70,    69,    71,    71,    71,    73,    72,    74,    72,
      75,    72,    76,    72,    77,    77,    78,    78,    79,    79
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const htmltype_int8 htmlr2[] =
{
       0,     2,     3,     3,     1,     1,     2,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     2,     0,     6,
       1,     3,     3,     3,     3,     3,     1,     0,     1,     2,
       3,     0,     4,     1,     2,     3,     0,     4,     0,     4,
       0,     4,     0,     3,     2,     1,     2,     1,     2,     1
};


enum { YYENOMEM = -2 };

#define htmlerrok         (htmlerrstatus = 0)
#define htmlclearin       (htmlchar = YYEMPTY)

#define YYACCEPT        goto htmlacceptlab
#define YYABORT         goto htmlabortlab
#define YYERROR         goto htmlerrorlab


#define YYRECOVERING()  (!!htmlerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (htmlchar == YYEMPTY)                                        \
      {                                                           \
        htmlchar = (Token);                                         \
        htmllval = (Value);                                         \
        YYPOPSTACK (htmllen);                                       \
        htmlstate = *htmlssp;                                         \
        goto htmlbackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        htmlerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (htmldebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (htmldebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      html_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
html_symbol_value_print (FILE *htmlo,
                       htmlsymbol_kind_t htmlkind, YYSTYPE const * const htmlvaluep)
{
  FILE *htmloutput = htmlo;
  YYUSE (htmloutput);
  if (!htmlvaluep)
    return;
# ifdef YYPRINT
  if (htmlkind < YYNTOKENS)
    YYPRINT (htmlo, htmltoknum[htmlkind], *htmlvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (htmlkind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
html_symbol_print (FILE *htmlo,
                 htmlsymbol_kind_t htmlkind, YYSTYPE const * const htmlvaluep)
{
  YYFPRINTF (htmlo, "%s %s (",
             htmlkind < YYNTOKENS ? "token" : "nterm", htmlsymbol_name (htmlkind));

  html_symbol_value_print (htmlo, htmlkind, htmlvaluep);
  YYFPRINTF (htmlo, ")");
}

/*------------------------------------------------------------------.
| html_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
html_stack_print (html_state_t *htmlbottom, html_state_t *htmltop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; htmlbottom <= htmltop; htmlbottom++)
    {
      int htmlbot = *htmlbottom;
      YYFPRINTF (stderr, " %d", htmlbot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (htmldebug)                                                  \
    html_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
html_reduce_print (html_state_t *htmlssp, YYSTYPE *htmlvsp,
                 int htmlrule)
{
  int htmllno = htmlrline[htmlrule];
  int htmlnrhs = htmlr2[htmlrule];
  int htmli;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             htmlrule - 1, htmllno);
  /* The symbols being reduced.  */
  for (htmli = 0; htmli < htmlnrhs; htmli++)
    {
      YYFPRINTF (stderr, "   $%d = ", htmli + 1);
      html_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+htmlssp[htmli + 1 - htmlnrhs]),
                       &htmlvsp[(htmli + 1) - (htmlnrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (htmldebug)                          \
    html_reduce_print (htmlssp, htmlvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int htmldebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
htmldestruct (const char *htmlmsg,
            htmlsymbol_kind_t htmlkind, YYSTYPE *htmlvaluep)
{
  YYUSE (htmlvaluep);
  if (!htmlmsg)
    htmlmsg = "Deleting";
  YY_SYMBOL_PRINT (htmlmsg, htmlkind, htmlvaluep, htmllocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (htmlkind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int htmlchar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE htmllval;
/* Number of syntax errors so far.  */
int htmlnerrs;




/*----------.
| htmlparse.  |
`----------*/

int
htmlparse (void)
{
    html_state_fast_t htmlstate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int htmlerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow htmloverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T htmlstacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    html_state_t htmlssa[YYINITDEPTH];
    html_state_t *htmlss = htmlssa;
    html_state_t *htmlssp = htmlss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE htmlvsa[YYINITDEPTH];
    YYSTYPE *htmlvs = htmlvsa;
    YYSTYPE *htmlvsp = htmlvs;

  int htmln;
  /* The return value of htmlparse.  */
  int htmlresult;
  /* Lookahead symbol kind.  */
  htmlsymbol_kind_t htmltoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE htmlval;



#define YYPOPSTACK(N)   (htmlvsp -= (N), htmlssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int htmllen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  htmlchar = YYEMPTY; /* Cause a token to be read.  */
  goto htmlsetstate;


/*------------------------------------------------------------.
| htmlnewstate -- push a new state, which is found in htmlstate.  |
`------------------------------------------------------------*/
htmlnewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  htmlssp++;


/*--------------------------------------------------------------------.
| htmlsetstate -- set current state (the top of the stack) to htmlstate.  |
`--------------------------------------------------------------------*/
htmlsetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", htmlstate));
  YY_ASSERT (0 <= htmlstate && htmlstate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *htmlssp = YY_CAST (html_state_t, htmlstate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (htmlss, htmlssp);

  if (htmlss + htmlstacksize - 1 <= htmlssp)
#if !defined htmloverflow && !defined YYSTACK_RELOCATE
    goto htmlexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T htmlsize = htmlssp - htmlss + 1;

# if defined htmloverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        html_state_t *htmlss1 = htmlss;
        YYSTYPE *htmlvs1 = htmlvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if htmloverflow is a macro.  */
        htmloverflow (YY_("memory exhausted"),
                    &htmlss1, htmlsize * YYSIZEOF (*htmlssp),
                    &htmlvs1, htmlsize * YYSIZEOF (*htmlvsp),
                    &htmlstacksize);
        htmlss = htmlss1;
        htmlvs = htmlvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= htmlstacksize)
        goto htmlexhaustedlab;
      htmlstacksize *= 2;
      if (YYMAXDEPTH < htmlstacksize)
        htmlstacksize = YYMAXDEPTH;

      {
        html_state_t *htmlss1 = htmlss;
        union htmlalloc *htmlptr =
          YY_CAST (union htmlalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (htmlstacksize))));
        if (! htmlptr)
          goto htmlexhaustedlab;
        YYSTACK_RELOCATE (htmlss_alloc, htmlss);
        YYSTACK_RELOCATE (htmlvs_alloc, htmlvs);
#  undef YYSTACK_RELOCATE
        if (htmlss1 != htmlssa)
          YYSTACK_FREE (htmlss1);
      }
# endif

      htmlssp = htmlss + htmlsize - 1;
      htmlvsp = htmlvs + htmlsize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, htmlstacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (htmlss + htmlstacksize - 1 <= htmlssp)
        YYABORT;
    }
#endif /* !defined htmloverflow && !defined YYSTACK_RELOCATE */

  if (htmlstate == YYFINAL)
    YYACCEPT;

  goto htmlbackup;


/*-----------.
| htmlbackup.  |
`-----------*/
htmlbackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  htmln = htmlpact[htmlstate];
  if (htmlpact_value_is_default (htmln))
    goto htmldefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (htmlchar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      htmlchar = htmllex ();
    }

  if (htmlchar <= YYEOF)
    {
      htmlchar = YYEOF;
      htmltoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (htmlchar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      htmlchar = YYUNDEF;
      htmltoken = YYSYMBOL_YYerror;
      goto htmlerrlab1;
    }
  else
    {
      htmltoken = YYTRANSLATE (htmlchar);
      YY_SYMBOL_PRINT ("Next token is", htmltoken, &htmllval, &htmllloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  htmln += htmltoken;
  if (htmln < 0 || YYLAST < htmln || htmlcheck[htmln] != htmltoken)
    goto htmldefault;
  htmln = htmltable[htmln];
  if (htmln <= 0)
    {
      if (htmltable_value_is_error (htmln))
        goto htmlerrlab;
      htmln = -htmln;
      goto htmlreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (htmlerrstatus)
    htmlerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", htmltoken, &htmllval, &htmllloc);
  htmlstate = htmln;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++htmlvsp = htmllval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  htmlchar = YYEMPTY;
  goto htmlnewstate;


/*-----------------------------------------------------------.
| htmldefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
htmldefault:
  htmln = htmldefact[htmlstate];
  if (htmln == 0)
    goto htmlerrlab;
  goto htmlreduce;


/*-----------------------------.
| htmlreduce -- do a reduction.  |
`-----------------------------*/
htmlreduce:
  /* htmln is the number of a rule to reduce with.  */
  htmllen = htmlr2[htmln];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  htmlval = htmlvsp[1-htmllen];


  YY_REDUCE_PRINT (htmln);
  switch (htmln)
    {
  case 2: /* html: T_html fonttext T_end_html  */
#line 447 "../../lib/common/htmlparse.y"
                                   { HTMLstate.lbl = mkLabel((htmlvsp[-1].txt),HTML_TEXT); }
#line 1782 "y.tab.c"
    break;

  case 3: /* html: T_html fonttable T_end_html  */
#line 448 "../../lib/common/htmlparse.y"
                                    { HTMLstate.lbl = mkLabel((htmlvsp[-1].tbl),HTML_TBL); }
#line 1788 "y.tab.c"
    break;

  case 4: /* html: error  */
#line 449 "../../lib/common/htmlparse.y"
              { cleanup(); YYABORT; }
#line 1794 "y.tab.c"
    break;

  case 5: /* fonttext: text  */
#line 452 "../../lib/common/htmlparse.y"
                { (htmlval.txt) = mkText(); }
#line 1800 "y.tab.c"
    break;

  case 8: /* textitem: string  */
#line 459 "../../lib/common/htmlparse.y"
                  { appendFItemList(HTMLstate.str);}
#line 1806 "y.tab.c"
    break;

  case 9: /* textitem: br  */
#line 460 "../../lib/common/htmlparse.y"
              {appendFLineList((htmlvsp[0].i));}
#line 1812 "y.tab.c"
    break;

  case 18: /* font: T_font  */
#line 471 "../../lib/common/htmlparse.y"
              { pushFont ((htmlvsp[0].font)); }
#line 1818 "y.tab.c"
    break;

  case 19: /* n_font: T_end_font  */
#line 474 "../../lib/common/htmlparse.y"
                    { popFont (); }
#line 1824 "y.tab.c"
    break;

  case 20: /* italic: T_italic  */
#line 477 "../../lib/common/htmlparse.y"
                  {pushFont((htmlvsp[0].font));}
#line 1830 "y.tab.c"
    break;

  case 21: /* n_italic: T_n_italic  */
#line 480 "../../lib/common/htmlparse.y"
                      {popFont();}
#line 1836 "y.tab.c"
    break;

  case 22: /* bold: T_bold  */
#line 483 "../../lib/common/htmlparse.y"
              {pushFont((htmlvsp[0].font));}
#line 1842 "y.tab.c"
    break;

  case 23: /* n_bold: T_n_bold  */
#line 486 "../../lib/common/htmlparse.y"
                  {popFont();}
#line 1848 "y.tab.c"
    break;

  case 24: /* strike: T_s  */
#line 489 "../../lib/common/htmlparse.y"
             {pushFont((htmlvsp[0].font));}
#line 1854 "y.tab.c"
    break;

  case 25: /* n_strike: T_n_s  */
#line 492 "../../lib/common/htmlparse.y"
                 {popFont();}
#line 1860 "y.tab.c"
    break;

  case 26: /* underline: T_underline  */
#line 495 "../../lib/common/htmlparse.y"
                        {pushFont((htmlvsp[0].font));}
#line 1866 "y.tab.c"
    break;

  case 27: /* n_underline: T_n_underline  */
#line 498 "../../lib/common/htmlparse.y"
                            {popFont();}
#line 1872 "y.tab.c"
    break;

  case 28: /* overline: T_overline  */
#line 501 "../../lib/common/htmlparse.y"
                      {pushFont((htmlvsp[0].font));}
#line 1878 "y.tab.c"
    break;

  case 29: /* n_overline: T_n_overline  */
#line 504 "../../lib/common/htmlparse.y"
                          {popFont();}
#line 1884 "y.tab.c"
    break;

  case 30: /* sup: T_sup  */
#line 507 "../../lib/common/htmlparse.y"
            {pushFont((htmlvsp[0].font));}
#line 1890 "y.tab.c"
    break;

  case 31: /* n_sup: T_n_sup  */
#line 510 "../../lib/common/htmlparse.y"
                {popFont();}
#line 1896 "y.tab.c"
    break;

  case 32: /* sub: T_sub  */
#line 513 "../../lib/common/htmlparse.y"
            {pushFont((htmlvsp[0].font));}
#line 1902 "y.tab.c"
    break;

  case 33: /* n_sub: T_n_sub  */
#line 516 "../../lib/common/htmlparse.y"
                {popFont();}
#line 1908 "y.tab.c"
    break;

  case 34: /* br: T_br T_end_br  */
#line 519 "../../lib/common/htmlparse.y"
                       { (htmlval.i) = (htmlvsp[-1].i); }
#line 1914 "y.tab.c"
    break;

  case 35: /* br: T_BR  */
#line 520 "../../lib/common/htmlparse.y"
              { (htmlval.i) = (htmlvsp[0].i); }
#line 1920 "y.tab.c"
    break;

  case 38: /* @1: %empty  */
#line 527 "../../lib/common/htmlparse.y"
                          { 
          if (nonSpace(agxbuse(HTMLstate.str))) {
            htmlerror ("Syntax error: non-space string used before <TABLE>");
            cleanup(); YYABORT;
          }
          (htmlvsp[0].tbl)->u.p.prev = HTMLstate.tblstack;
          (htmlvsp[0].tbl)->u.p.rows = dtopen(&rowDisc, Dtqueue);
          HTMLstate.tblstack = (htmlvsp[0].tbl);
          (htmlvsp[0].tbl)->font = HTMLstate.fontstack->cfont;
          (htmlval.tbl) = (htmlvsp[0].tbl);
        }
#line 1936 "y.tab.c"
    break;

  case 39: /* table: opt_space T_table @1 rows T_end_table opt_space  */
#line 538 "../../lib/common/htmlparse.y"
                                   {
          if (nonSpace(agxbuse(HTMLstate.str))) {
            htmlerror ("Syntax error: non-space string used after </TABLE>");
            cleanup(); YYABORT;
          }
          (htmlval.tbl) = HTMLstate.tblstack;
          HTMLstate.tblstack = HTMLstate.tblstack->u.p.prev;
        }
#line 1949 "y.tab.c"
    break;

  case 40: /* fonttable: table  */
#line 548 "../../lib/common/htmlparse.y"
                  { (htmlval.tbl) = (htmlvsp[0].tbl); }
#line 1955 "y.tab.c"
    break;

  case 41: /* fonttable: font table n_font  */
#line 549 "../../lib/common/htmlparse.y"
                              { (htmlval.tbl)=(htmlvsp[-1].tbl); }
#line 1961 "y.tab.c"
    break;

  case 42: /* fonttable: italic table n_italic  */
#line 550 "../../lib/common/htmlparse.y"
                                  { (htmlval.tbl)=(htmlvsp[-1].tbl); }
#line 1967 "y.tab.c"
    break;

  case 43: /* fonttable: underline table n_underline  */
#line 551 "../../lib/common/htmlparse.y"
                                        { (htmlval.tbl)=(htmlvsp[-1].tbl); }
#line 1973 "y.tab.c"
    break;

  case 44: /* fonttable: overline table n_overline  */
#line 552 "../../lib/common/htmlparse.y"
                                      { (htmlval.tbl)=(htmlvsp[-1].tbl); }
#line 1979 "y.tab.c"
    break;

  case 45: /* fonttable: bold table n_bold  */
#line 553 "../../lib/common/htmlparse.y"
                              { (htmlval.tbl)=(htmlvsp[-1].tbl); }
#line 1985 "y.tab.c"
    break;

  case 48: /* rows: row  */
#line 560 "../../lib/common/htmlparse.y"
           { (htmlval.p) = (htmlvsp[0].p); }
#line 1991 "y.tab.c"
    break;

  case 49: /* rows: rows row  */
#line 561 "../../lib/common/htmlparse.y"
                { (htmlval.p) = (htmlvsp[0].p); }
#line 1997 "y.tab.c"
    break;

  case 50: /* rows: rows HR row  */
#line 562 "../../lib/common/htmlparse.y"
                   { (htmlvsp[-2].p)->ruled = 1; (htmlval.p) = (htmlvsp[0].p); }
#line 2003 "y.tab.c"
    break;

  case 51: /* $@2: %empty  */
#line 565 "../../lib/common/htmlparse.y"
            { addRow (); }
#line 2009 "y.tab.c"
    break;

  case 52: /* row: T_row $@2 cells T_end_row  */
#line 565 "../../lib/common/htmlparse.y"
                                           { (htmlval.p) = lastRow(); }
#line 2015 "y.tab.c"
    break;

  case 53: /* cells: cell  */
#line 568 "../../lib/common/htmlparse.y"
             { (htmlval.cell) = (htmlvsp[0].cell); }
#line 2021 "y.tab.c"
    break;

  case 54: /* cells: cells cell  */
#line 569 "../../lib/common/htmlparse.y"
                   { (htmlval.cell) = (htmlvsp[0].cell); }
#line 2027 "y.tab.c"
    break;

  case 55: /* cells: cells VR cell  */
#line 570 "../../lib/common/htmlparse.y"
                      { (htmlvsp[-2].cell)->ruled |= HTML_VRULE; (htmlval.cell) = (htmlvsp[0].cell); }
#line 2033 "y.tab.c"
    break;

  case 56: /* $@3: %empty  */
#line 573 "../../lib/common/htmlparse.y"
                        { setCell((htmlvsp[-1].cell),(htmlvsp[0].tbl),HTML_TBL); }
#line 2039 "y.tab.c"
    break;

  case 57: /* cell: T_cell fonttable $@3 T_end_cell  */
#line 573 "../../lib/common/htmlparse.y"
                                                                { (htmlval.cell) = (htmlvsp[-3].cell); }
#line 2045 "y.tab.c"
    break;

  case 58: /* $@4: %empty  */
#line 574 "../../lib/common/htmlparse.y"
                       { setCell((htmlvsp[-1].cell),(htmlvsp[0].txt),HTML_TEXT); }
#line 2051 "y.tab.c"
    break;

  case 59: /* cell: T_cell fonttext $@4 T_end_cell  */
#line 574 "../../lib/common/htmlparse.y"
                                                                { (htmlval.cell) = (htmlvsp[-3].cell); }
#line 2057 "y.tab.c"
    break;

  case 60: /* $@5: %empty  */
#line 575 "../../lib/common/htmlparse.y"
                    { setCell((htmlvsp[-1].cell),(htmlvsp[0].img),HTML_IMAGE); }
#line 2063 "y.tab.c"
    break;

  case 61: /* cell: T_cell image $@5 T_end_cell  */
#line 575 "../../lib/common/htmlparse.y"
                                                              { (htmlval.cell) = (htmlvsp[-3].cell); }
#line 2069 "y.tab.c"
    break;

  case 62: /* $@6: %empty  */
#line 576 "../../lib/common/htmlparse.y"
              { setCell((htmlvsp[0].cell),mkText(),HTML_TEXT); }
#line 2075 "y.tab.c"
    break;

  case 63: /* cell: T_cell $@6 T_end_cell  */
#line 576 "../../lib/common/htmlparse.y"
                                                             { (htmlval.cell) = (htmlvsp[-2].cell); }
#line 2081 "y.tab.c"
    break;

  case 64: /* image: T_img T_end_img  */
#line 579 "../../lib/common/htmlparse.y"
                         { (htmlval.img) = (htmlvsp[-1].img); }
#line 2087 "y.tab.c"
    break;

  case 65: /* image: T_IMG  */
#line 580 "../../lib/common/htmlparse.y"
               { (htmlval.img) = (htmlvsp[0].img); }
#line 2093 "y.tab.c"
    break;


#line 2097 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter htmlchar, and that requires
     that htmltoken be updated with the new translation.  We take the
     approach of translating immediately before every use of htmltoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering htmlchar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (htmlsymbol_kind_t, htmlr1[htmln]), &htmlval, &htmlloc);

  YYPOPSTACK (htmllen);
  htmllen = 0;

  *++htmlvsp = htmlval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int htmllhs = htmlr1[htmln] - YYNTOKENS;
    const int htmli = htmlpgoto[htmllhs] + *htmlssp;
    htmlstate = (0 <= htmli && htmli <= YYLAST && htmlcheck[htmli] == *htmlssp
               ? htmltable[htmli]
               : htmldefgoto[htmllhs]);
  }

  goto htmlnewstate;


/*--------------------------------------.
| htmlerrlab -- here on detecting error.  |
`--------------------------------------*/
htmlerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  htmltoken = htmlchar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (htmlchar);
  /* If not already recovering from an error, report this error.  */
  if (!htmlerrstatus)
    {
      ++htmlnerrs;
      htmlerror (YY_("syntax error"));
    }

  if (htmlerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (htmlchar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (htmlchar == YYEOF)
            YYABORT;
        }
      else
        {
          htmldestruct ("Error: discarding",
                      htmltoken, &htmllval);
          htmlchar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto htmlerrlab1;


/*---------------------------------------------------.
| htmlerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
htmlerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label htmlerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (htmllen);
  htmllen = 0;
  YY_STACK_PRINT (htmlss, htmlssp);
  htmlstate = *htmlssp;
  goto htmlerrlab1;


/*-------------------------------------------------------------.
| htmlerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
htmlerrlab1:
  htmlerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      htmln = htmlpact[htmlstate];
      if (!htmlpact_value_is_default (htmln))
        {
          htmln += YYSYMBOL_YYerror;
          if (0 <= htmln && htmln <= YYLAST && htmlcheck[htmln] == YYSYMBOL_YYerror)
            {
              htmln = htmltable[htmln];
              if (0 < htmln)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (htmlssp == htmlss)
        YYABORT;


      htmldestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (htmlstate), htmlvsp);
      YYPOPSTACK (1);
      htmlstate = *htmlssp;
      YY_STACK_PRINT (htmlss, htmlssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++htmlvsp = htmllval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (htmln), htmlvsp, htmllsp);

  htmlstate = htmln;
  goto htmlnewstate;


/*-------------------------------------.
| htmlacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
htmlacceptlab:
  htmlresult = 0;
  goto htmlreturn;


/*-----------------------------------.
| htmlabortlab -- YYABORT comes here.  |
`-----------------------------------*/
htmlabortlab:
  htmlresult = 1;
  goto htmlreturn;


#if !defined htmloverflow
/*-------------------------------------------------.
| htmlexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
htmlexhaustedlab:
  htmlerror (YY_("memory exhausted"));
  htmlresult = 2;
  goto htmlreturn;
#endif


/*-------------------------------------------------------.
| htmlreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
htmlreturn:
  if (htmlchar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      htmltoken = YYTRANSLATE (htmlchar);
      htmldestruct ("Cleanup: discarding lookahead",
                  htmltoken, &htmllval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (htmllen);
  YY_STACK_PRINT (htmlss, htmlssp);
  while (htmlssp != htmlss)
    {
      htmldestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*htmlssp), htmlvsp);
      YYPOPSTACK (1);
    }
#ifndef htmloverflow
  if (htmlss != htmlssa)
    YYSTACK_FREE (htmlss);
#endif

  return htmlresult;
}

#line 592 "../../lib/common/htmlparse.y"


/* parseHTML:
 * Return parsed label or NULL if failure.
 * Set warn to 0 on success; 1 for warning message; 2 if no expat.
 */
htmllabel_t*
parseHTML (char* txt, int* warn, htmlenv_t *env)
{
  unsigned char buf[SMALLBUF];
  agxbuf        str;
  htmllabel_t*  l;
  sfont_t       dfltf;

  dfltf.cfont = NULL;
  dfltf.pfont = NULL;
  HTMLstate.fontstack = &dfltf;
  HTMLstate.tblstack = 0;
  HTMLstate.lbl = 0;
  HTMLstate.gvc = GD_gvc(env->g);
  HTMLstate.fitemList = dtopen(&fstrDisc, Dtqueue);
  HTMLstate.fspanList = dtopen(&fspanDisc, Dtqueue);

  agxbinit (&str, SMALLBUF, buf);
  HTMLstate.str = &str;
  
  if (initHTMLlexer (txt, &str, env)) {/* failed: no libexpat - give up */
    *warn = 2;
    l = NULL;
  }
  else {
    htmlparse();
    *warn = clearHTMLlexer ();
    l = HTMLstate.lbl;
  }

  dtclose (HTMLstate.fitemList);
  dtclose (HTMLstate.fspanList);
  
  HTMLstate.fitemList = NULL;
  HTMLstate.fspanList = NULL;
  HTMLstate.fontstack = NULL;
  
  agxbfree (&str);

  return l;
}

